mithril.js [![NPM Version](https://img.shields.io/npm/v/mithril.svg)](https://www.npmjs.com/package/mithril) [![NPM License](https://img.shields.io/npm/l/mithril.svg)](https://www.npmjs.com/package/mithril) [![NPM Downloads](https://img.shields.io/npm/dm/mithril.svg)](https://www.npmjs.com/package/mithril)
==========

<p align="center">
	<a href="https://travis-ci.org/MithrilJS/mithril.js">
		<img src="https://img.shields.io/travis/MithrilJS/mithril.js/next.svg" alt="Build Status">
	</a>
	<a href="https://gitter.im/mithriljs/mithril.js">
		<img src="https://img.shields.io/gitter/room/mithriljs/mithril.js.svg" alt="Gitter" />
	</a>
</p>

- [What is Mithril?](#what-is-mithril)
- [Installation](#installation)
- [Documentation](#documentation)
- [Getting Help](#getting-help)
- [Contributing](#contributing)

## What is Mithril?

A modern client-side Javascript framework for building Single Page Applications. It's small (<!-- size -->8.88 KB<!-- /size --> gzipped), fast and provides routing and XHR utilities out of the box.

Mithril is used by companies like Vimeo and Nike, and open source platforms like Lichess 👍.

Mithril supports IE11, Firefox ESR, and the last two versions of Firefox, Edge, Safari, and Chrome. No polyfills required. 👌

## Installation

### CDN

```html
<script src="https://unpkg.com/mithril"></script>
<!-- or -->
<script src="https://cdn.jsdelivr.net/npm/mithril/mithril.js"></script>
```

### npm
```bash
# For the most recent stable version
$ npm install mithril --save
# For the most recent unstable version
$ npm install mithril@next --save
```

The ["Getting started" guide](https://mithril.js.org/#getting-started) is a good place to start learning how to use mithril.

## Documentation

Documentation lives on [mithril.js.org](https://mithril.js.org).

You may be interested in the [API Docs](https://mithril.js.org/api.html), a [Simple Application](https://mithril.js.org/simple-application.html), or perhaps some [Examples](https://mithril.js.org/examples.html).

## Getting Help

Mithril has an active & welcoming community on [Gitter](https://gitter.im/mithriljs/mithril.js), or feel free to ask questions on [Stack Overflow](https://stackoverflow.com/questions/tagged/mithril.js) using the `mithril.js` tag.

## Contributing

There's a [Contributing FAQ](https://mithril.js.org/contributing.html) on the mithril site that hopefully helps, but if not definitely hop into the [Gitter Room](https://gitter.im/mithriljs/mithril.js) and ask away!

---

Thanks for reading!

🎁
